
The Path Avoiding Forbidden Pairs (PAFP) problem asks whether, in a directed graph G with terminals s and t and a set ℱ of forbidden vertex pairs, there is an s–t path that includes at most one endpoint from each pair. A standard width-based tractable regime for PAFP is obtained by adding the forbidden pairs as edges to form an undirected union/constraint graph and requiring that graph to have bounded treewidth or pathwidth. We initiate the study of PAFP under a layer-based width measure. Let the BFS layer L_d be the set of vertices at directed shortest-path distance d from s, and define the BFS-width from s as max _d |L_d| . We show that PAFP on DAGs remains NP-complete even when the union digraph G∪ℱ —obtained by adding to G one arc per forbidden pair, oriented forward in a fixed deterministic topological order—is itself a DAG of BFS-width at most 2. We do this by giving a constructive polynomial-time transformation that converts any DAG PAFP instance into an equivalent DAG PAFP instance whose union digraph has BFS-width at most 2. We also study exact-length layers, namely the sets of vertices reachable from s by a directed path of length exactly d. We show that PAFP, when the input graph is a DAG whose exact-length layers are of size at most 2, is in P; this width bound is tight, since a classical layered reduction already yields NP-completeness on DAGs of exact-length width 3. Previously studied polynomial-time cases of PAFP impose restrictions on ℱ in order to achieve tractability, whereas our exact-length width-2 case combines unrestricted forbidden pairs with input graphs that may have exponentially many s–t paths.
Clique coloring of a graph is a relaxation of proper vertex coloring that requires every maximal clique to contain at least two distinct colors. In this paper, we introduce and study an optimization variant called Minimum Clique Bicoloring, which restricts the available colors to white and black and asks to minimize the number of black-colored vertices, and can be viewed as a coloring-type counterpart of the classical minimum clique transversal problem. We show that Minimum Clique Bicoloring is Σ_^ -hard even on weakly chordal graphs, and NP-complete on cubic planar graphs and on k-sun-free chordal graphs for every fixed k ≥ 4 . On split graphs, we further relate Minimum Clique Bicoloring to the minimum clique transversal problem by showing that any polynomial-time algorithm for the latter yields one for Minimum Clique Bicoloring. Regarding parameterized complexity, we also show that the problem is [2] -hard when parameterized by the number of black vertices k, but fixed-parameter tractable (FPT) with respect to clique-width. Furthermore, we present a polynomial-time algorithm for Minimum Clique Bicoloring on totally unimodular graphs, and, as consequences of our structural and parameterized results, we obtain polynomial-time solvability on several further well-studied graph classes. Finally, we give an exact exponential algorithm running in O^*(2^n) time, which improves on a straightforward O^*((2 · 3^1/3)^n) approach based on maximal-clique enumeration, where n is the number of vertices. These results nearly pinpoint the boundary between polynomial-time solvability and intractability of Minimum Clique Bicoloring on standard graph classes; the remaining main gap concerns strongly chordal graphs.
Suppose that a group test operation is available for checking order relations in a set, can this speed up problems like finding the minimum/maximum element, determining the rank of element, and computing order statistics? We consider a one-sided group inequality test to be available, where queries are of the form u ≤ _Q V or V ≤ _Q u , and the answer is ‘yes’ if and only if there is some v ∈ V such that u ≤ v or v ≤ u , respectively. We restrict attention to total orders and focus on query-complexity; for min or max finding, we give a Las Vegas algorithm that makes 𝒪(log ^2 n) expected queries. We observe that rank determination can be solved with existing “defect-counting” algorithms, but also give a simple Monte Carlo approximation algorithm with expected query complexity , where 1-ϵ is the probability that the algorithm succeeds and we allow a relative error of 1 ±δ for δ > 0 in the estimated rank. We then give a Monte Carlo algorithm for approximate selection that has expected query complexity ; it has probability at least 1/2 to output an element x, and if so, x has the desired approximate rank with probability 1-ϵ .
Bounded integer compositions are fundamental combinatorial objects employed in cryptography, yet they lack a unified theoretical treatment and efficient implementations for combinatorial (un)ranking. We propose generic algorithms that allow us to describe proposals found in the literature as specific parameter sets. Consequently, we are able to provide a single proof of correctness that applies simultaneously to all derived algorithms; characterize a number of ad hoc optimizations with respect to our generic framework; and discuss the storage complexity of pre-computed combinatorial count tables. Furthermore, drawing on Gaussian limit laws from analytic combinatorics, we propose performance and storage optimizations for the particular case of uniform random inputs to (un)ranking algorithms, a common setting in cryptographic applications. To validate our results, we give portable low-level implementations ready for use by algorithm designers, filling a practical gap in the literature.